package org.eclipse.gef.asindesigner.actions;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.gef.asindesigner.AsinMessages;
import org.eclipse.gef.asinview.AsinView;
import org.eclipse.gef.asindesigner.AsinEditor;
import org.eclipse.gef.asindesigner.model.AsinDiagram;
import org.eclipse.gef.asindesigner.model.AsinLabel;
import org.eclipse.gef.asindesigner.model.AsinSubpart;
import org.eclipse.gef.asindesigner.model.LambdaAlternative;
import org.eclipse.gef.asindesigner.model.LeftSide;
import org.eclipse.gef.asindesigner.model.NTerminal;
import org.eclipse.gef.ui.actions.WorkbenchPartAction;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.ui.IWorkbenchPart;
public class GenerateGramaticAction extends WorkbenchPartAction {
	AsinDiagram ld;
	int cont;
	public static final String GENERATE = "Generate"; //$NON-NLS-1$
	public GenerateGramaticAction(IWorkbenchPart part) {
		super(part);
		ld = ((AsinEditor) part).getLogicDiagram();
		setText(AsinMessages.GrammarGenerateCommand_Text);
		setId(GENERATE);
	}

	protected boolean calculateEnabled() {
		return canPerformAction();
	}

	private boolean canPerformAction() {
		return true;
	}

	PrintWriter out;
	String path = new String("");

	public void run() {		
		Display display = Display.getDefault();
		FileDialog dialog = new FileDialog(display.getActiveShell(), SWT.SAVE);
		String name = dialog.open();
		path = name;		
		
		
		/*para cima  so teste*/
		try {
			FileWriter fileOut = new FileWriter(path);
			out = new PrintWriter(new BufferedWriter(fileOut));
		} catch (IOException e) {
			AsinView.displayText("File writer exception.....");
			out = null;
		}
		List children;
		ArrayList start = new ArrayList();
		children = ld.getChildren();
		Object o;
		AsinView.displayText("run grammar generate...\n");
		/*Com o lao a seguir colocarei todos os ns LeftSide, que apontam para o comeo
		 * de uma produo no vetor start. Esse vetor ento guardar todos as cabeas das
		 * produes.*/
		for (int i = 0; i < children.size(); i++) {
			o = children.get(i);
			/*Colocando false no flag, para fazer a busca em profundidade*/
			if (o instanceof AsinSubpart)
				 ((AsinSubpart) o).setFlag(false);
			/*Se o n for cabea de uma produo, coloco-o no vetor start.*/
			if (o instanceof LeftSide) {
				start.add((AsinDiagram)o);
			}
		}
		AsinSubpart head = null;
		for (int i = 0; i < start.size(); i++) {
			AsinView.displayText("Begining a new leftside..\n");
			cont = 0;
			head = (AsinSubpart)((AsinDiagram)start.get(i)).getSucessor();
			head.setNumber(++cont);
			List listChildren = ((AsinDiagram) start.get(i)).getChildren();
			AsinLabel label = (AsinLabel) listChildren.iterator().next();
			
			/*preparando a string 'sout', que ser escrita no arquivo*/
			String sout = "H " + label.getLabelContents() + " -1 -1 -1 -1\n";
			if (out != null) {
				out.write(sout);
				out.flush();
				AsinView.displayText(sout);
			}
			/*chamando a busca em profundidade para o primeiro n da produo*/
			dfs(head);
		}
	}

	public void dfs(AsinSubpart o) {
		String name_smRoutine[];
		name_smRoutine = new String[2];
		name_smRoutine[0] = new String("-1");
		name_smRoutine[1] = new String("-1");
		if (o instanceof AsinDiagram ||o instanceof LambdaAlternative ) {
			/*Marcando o n, para que ele no seja percorrido mais de uma vez.*/
			o.setFlag(true);
			/*O Sucessor do n atual (o)  preenchido*/
			AsinSubpart suc = (AsinSubpart)o.getSucessor();
			/*A alternativa do n atual  preenchida*/
			AsinSubpart alt = (AsinSubpart)o.getAlternative();
			
			/*se o sucessor existir e ainda no foi percorrido, ganha um nmero
			 * de indentificao*/
			if (suc != null && suc.getFlag() == false) {
				suc.setNumber(++cont);
			}
			/*se o n alternativo existir e ainda no foi percorrido, ganha um nmero 
			 * de indentificao*/
			if (alt != null && alt.getFlag() == false) {
				alt.setNumber(++cont);
			}
			/*inicializando a string que ser utilizada para guardar os dados do n atual*/
			String sout = "";
			
			/*O n  um no terminal?*/
			if (o instanceof NTerminal)
				sout = sout + "N";
			else sout = sout + "T";
			
			/*Nesse ponto temos que entrar no contedo do n terminal ou no terminal,
			 * para saber qual  a sua entrada. Com esse dado, preenchere-mos o campo 
			 * nomer*/
			if(o instanceof AsinDiagram){	
				List listChildren = ((AsinDiagram) o).getChildren();
				AsinLabel label = (AsinLabel) listChildren.iterator().next();
				name_smRoutine = nameAndRsExtractor(label.getLabelContents());
				sout = sout + " " + name_smRoutine[0];
			/*Se for um lambda-n, o nomer  preenchido com a string "-1"*/
			}else if (o instanceof LambdaAlternative){
				sout = sout + " -1";
			}
			
			/*Agora est na hora de preencher o campo numno, que indica qual o nmero desse n*/
			sout = sout + " " + o.getNumber();
			
			/*Colocando um valor no campo Altr, que indica o n alternativo ao n "o".*/
			if (alt == null )
				sout = sout + " 0";
			else
				sout = sout + " " + alt.getNumber();
			/*Colocando um valor no campo Sucr, que indica o n sucessor ao n "o"*/
			if (suc == null )
				sout = sout + " 0";
			else
				sout = sout + " " + suc.getNumber();
				
			/*Este nmero  referente  rotina semntica.*/
			sout = sout + " "+name_smRoutine[1]+"\n";
			
			/*imprimindo os dados do n atual (o) no arquivo...*/
			if (out != null) {
				out.write(sout);
				out.flush();
			}
			/*imprimindo os dados do n atual (o) na tela...*/
			AsinView.displayText(sout);
			
			/*chamando a recurso para o n sucessor (busca em profundidade)*/
			if (suc != null && suc.getFlag() == false)
				dfs(suc);
			/*chamando a recurso para o n alternativo (busca em profundidade)*/
			if (alt != null && alt.getFlag() == false)
				dfs(alt);
		}
	}
	/*This function extracts the name and the routine semantic number from one string*/
	private String[] nameAndRsExtractor(String text){
		String name;
		String sr;
		String[] str = new String[2];
		String[] ret = new String[2];
		str = text.split("#");
		name = str[0];
		if(str.length >= 2){
			if(str[1].matches("[0-9]+")){
		       sr = str[1];
			}
			else sr = "-1";
		}
		else sr = "-1";	
		ret[0]= new String(name);
		ret[1]= new String(sr);
		return ret;
	}

}
