package org.eclipse.gef.asindesigner.actions;

import java.io.PrintWriter;

import org.eclipse.gef.asindesigner.AsinMessages;
import org.eclipse.gef.asindesigner.AsinEditor;
import org.eclipse.gef.asindesigner.model.AsinDiagram;
import org.eclipse.gef.asindesigner.model.analisador.Asin;
import org.eclipse.gef.asindesigner.model.analisador.CarregadorSintatico;
import org.eclipse.gef.asindesigner.model.analisador.TabCreate;
import org.eclipse.gef.ui.actions.WorkbenchPartAction;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbenchPart;
public class ParseAction extends WorkbenchPartAction {
	AsinDiagram ld;
	int cont;
	public static final String PARSE = "Parse"; //$NON-NLS-1$

	public ParseAction(IWorkbenchPart part) {
		super(part);
		ld = ((AsinEditor) part).getLogicDiagram();
		setText(AsinMessages.ParsingAction_Text);
		setId(PARSE);
	}

	protected boolean calculateEnabled() {
		return canPerformAction();
	}

	private boolean canPerformAction() {
		return true;
	}

	PrintWriter out;
	String path = "";

	public void run() {	
		final Text grammarFile;
		final Text sourceFile;	
		Display display = Display.getDefault();
		GridLayout layout = new GridLayout();
		Shell shell = new Shell();
		layout.numColumns = 3;
		shell.setLayout(layout);		
		shell.setText("Parsing");
		
		new Label(shell, SWT.NONE).setText("Grammar File:");
		grammarFile = new Text(shell, SWT.SINGLE | SWT.BORDER);
		grammarFile.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		Button browse1 = new Button(shell, SWT.PUSH);
		browse1.setText("Browse");
		
		
		new Label(shell, SWT.NONE).setText("Source File:");
		sourceFile = new Text(shell, SWT.SINGLE | SWT.BORDER);
		sourceFile.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		Button browse2 = new Button(shell, SWT.PUSH);
		browse2.setText("Browse");
		
		Button parseStart = new Button(shell, SWT.PUSH);
		parseStart.setText("Parse");
		
		final FileDialog dialog = new FileDialog(display.getActiveShell(), SWT.OPEN);
		browse1.addSelectionListener(new SelectionAdapter() {
		  public void widgetSelected(SelectionEvent event) {			
	 		String name = dialog.open();
	  		path = name;
	  		grammarFile.setText(name);		 
		  }
		});
		
		final FileDialog dialog2 = new FileDialog(display.getActiveShell(), SWT.OPEN);
		browse2.addSelectionListener(new SelectionAdapter() {
		  public void widgetSelected(SelectionEvent event) {			
			String name = dialog2.open();
			path = name;
			sourceFile.setText(name);		 
		  }
		});
		
		parseStart.addSelectionListener(new SelectionAdapter() {
				  public void widgetSelected(SelectionEvent event) {
				  	TabCreate t = new TabCreate(grammarFile.getText());			
					CarregadorSintatico c = new CarregadorSintatico(t);
					Asin asin = new Asin(c.tabGraph(), c.tabT(), c.tabNt(),sourceFile.getText());
					//System.out.println("OK");		 
				  }
				});		
	
		
		
		shell.pack();
		shell.open();
		
		
		while (!shell.isDisposed()) {
			 if (!display.readAndDispatch())
			 	display.sleep();
		}
					
	}		

}
