package org.eclipse.gef.asindesigner.edit;

import java.util.List;

import org.eclipse.gef.AccessibleEditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.asindesigner.model.AsinDiagram;
import org.eclipse.swt.accessibility.AccessibleEvent;


/**
 * Provides support for Container EditParts.
 */
abstract public class AsinContainerEditPart
	extends AsinEditPart
{
protected AccessibleEditPart createAccessible() {
	return new AccessibleGraphicalEditPart(){
		public void getName(AccessibleEvent e) {
			e.result = getLogicDiagram().toString();
		}
	};
}

/**
 * Installs the desired EditPolicies for this.
 */
protected void createEditPolicies() {
	super.createEditPolicies();
	installEditPolicy(EditPolicy.CONTAINER_ROLE, new AsinContainerEditPolicy());
	installEditPolicy(EditPolicy.LAYOUT_ROLE, new AsinXYLayoutEditPolicy());
}

/**
 * Returns the model of this as a AsinDiagram.
 *
 * @return  AsinDiagram of this.
 */
protected AsinDiagram getLogicDiagram() {
	return (AsinDiagram)getModel();
}

/**
 * Returns the children of this through the model.
 *
 * @return  Children of this as a List.
 */
protected List getModelChildren() {
	return getLogicDiagram().getChildren();
}

}
