package org.eclipse.gef.asindesigner.edit;

import java.util.List;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.asindesigner.AsinMessages;
import org.eclipse.gef.asindesigner.model.AsinDiagram;
import org.eclipse.gef.asindesigner.model.AsinSubpart;
import org.eclipse.gef.asindesigner.model.commands.OrphanChildCommand;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gef.editpolicies.ContainerEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gef.requests.GroupRequest;

public class AsinContainerEditPolicy
	extends ContainerEditPolicy
{

protected Command getCreateCommand(CreateRequest request) {
	return null;
}

public Command getOrphanChildrenCommand(GroupRequest request) {
	List parts = request.getEditParts();
	CompoundCommand result = 
		new CompoundCommand(AsinMessages.AsinContainerEditPolicy_OrphanCommandLabelText);
	for (int i = 0; i < parts.size(); i++) {
		OrphanChildCommand orphan = new OrphanChildCommand();
		orphan.setChild((AsinSubpart)((EditPart)parts.get(i)).getModel());
		orphan.setParent((AsinDiagram)getHost().getModel());
		orphan.setLabel(AsinMessages.AsinElementEditPolicy_OrphanCommandLabelText);
		result.add(orphan);
	}
	return result.unwrap();
}

}