package org.eclipse.gef.asindesigner.edit;

import java.util.List;

import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.RootEditPart;
import org.eclipse.gef.asindesigner.model.AsinDiagram;
import org.eclipse.gef.editpolicies.RootComponentEditPolicy;

/**
 * Tree EditPart for the Container.
 */
public class AsinContainerTreeEditPart
	extends AsinTreeEditPart
{

/**
 * Constructor, which initializes this using the
 * model given as input.
 */
public AsinContainerTreeEditPart(Object model) {
	super(model);
}

/**
 * Creates and installs pertinent EditPolicies.
 */
protected void createEditPolicies() {
	super.createEditPolicies();
	installEditPolicy(EditPolicy.CONTAINER_ROLE, new AsinContainerEditPolicy());
	installEditPolicy(EditPolicy.TREE_CONTAINER_ROLE, new AsinTreeContainerEditPolicy());
	//If this editpart is the contents of the viewer, then it is not deletable!
	if (getParent() instanceof RootEditPart)
		installEditPolicy(EditPolicy.COMPONENT_ROLE, new RootComponentEditPolicy());
}

/**
 * Returns the model of this as a AsinDiagram.
 *
 * @return  Model of this.
 */
protected AsinDiagram getLogicDiagram() {
	return (AsinDiagram)getModel();
}

/**
 * Returns the children of this from the model,
 * as this is capable enough of holding EditParts.
 *
 * @return  List of children.
 */
protected List getModelChildren() {
	return getLogicDiagram().getChildren();
}

}