package org.eclipse.gef.asindesigner.edit;


import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.asindesigner.model.AsinDiagram;
import org.eclipse.gef.asindesigner.model.AsinFlowContainer;
import org.eclipse.gef.asindesigner.model.AsinSubpart;
import org.eclipse.gef.asindesigner.model.commands.AddCommand;
import org.eclipse.gef.asindesigner.model.commands.CreateCommand;
import org.eclipse.gef.asindesigner.model.commands.ReorderPartCommand;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreateRequest;

public class AsinFlowEditPolicy
	extends org.eclipse.gef.editpolicies.FlowLayoutEditPolicy
{

protected Command createAddCommand(EditPart child, EditPart after) {
	AddCommand command = new AddCommand();
	command.setChild((AsinSubpart)child.getModel());
	command.setParent((AsinFlowContainer)getHost().getModel());
	int index = getHost().getChildren().indexOf(after);
	command.setIndex(index);
	return command;
}

protected Command createMoveChildCommand(EditPart child, EditPart after) {
	AsinSubpart childModel = (AsinSubpart)child.getModel();
	AsinDiagram parentModel = (AsinDiagram)getHost().getModel();
	int oldIndex = getHost().getChildren().indexOf(child);
	int newIndex = getHost().getChildren().indexOf(after);
	if (newIndex > oldIndex)
		newIndex--;
	ReorderPartCommand command = new ReorderPartCommand(childModel, parentModel, oldIndex, newIndex);
	return command;
}

protected Command getCreateCommand(CreateRequest request) {
	CreateCommand command = new CreateCommand();
	EditPart after = getInsertionReference(request);
	command.setChild((AsinSubpart)request.getNewObject());
	command.setParent((AsinFlowContainer)getHost().getModel());
	int index = getHost().getChildren().indexOf(after);
	command.setIndex(index);
	return command;
}

protected Command getDeleteDependantCommand(Request request) {
	return null;
}

protected Command getOrphanChildrenCommand(Request request) {
	return null;
}

}