package org.eclipse.gef.asindesigner.edit;

import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Text;

final public class LabelCellEditorLocator
	implements CellEditorLocator
{

private Label label;

public LabelCellEditorLocator(Label label) {
	setLabel(label);
}

public void relocate(CellEditor celleditor) {
	Text text = (Text)celleditor.getControl();
	Point pref = text.computeSize(-1, -1);
	Rectangle rect = label.getTextBounds().getCopy();
	label.translateToAbsolute(rect);
	text.setBounds(rect.x-4, rect.y-1, pref.x+1, pref.y+1);	
}

/**
 * Returns the Label figure.
 */
protected Label getLabel() {
	return label;
}

/**
 * Sets the label.
 * @param label The label to set
 */
protected void setLabel(Label label) {
	this.label = label;
}

}
