package org.eclipse.gef.asindesigner.figures;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.PointList;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.asindesigner.model.EndNode;

/**
 * @author danlee
 */
public class EndNodeFigure extends GateFigure {

	private static final Dimension SIZE = new Dimension(15, 17);

	/**
	 * Constructor for EndNodeFigure.
	 */
	public EndNodeFigure() {
		FixedConnectionAnchor inputConnectionAnchorA;// inputConnectionAnchorB;
		inputConnectionAnchorA = new FixedConnectionAnchor(this);
		inputConnectionAnchorA.offsetH = 4;
		inputConnectionAnchorA.offsetV = 7;
		inputConnectionAnchors.addElement(inputConnectionAnchorA);
		connectionAnchors.put(EndNode.TERMINAL_A, inputConnectionAnchorA);
		setBackgroundColor(AsinColorConstants.andGate);
	}

	/**
	 * @see org.eclipse.draw2d.Figure#getPreferredSize(int, int)
	 */
	public Dimension getPreferredSize(int wHint, int hHint) {
		return SIZE;
	}

	/**
	 * @see org.eclipse.draw2d.Figure#paintFigure(Graphics)
	 */
	protected void paintFigure(Graphics g) {
		PointList leftSide = new PointList();
		Rectangle r = getBounds().getCopy();
		r.translate(2, 2);
		r.setSize(11, 9);		
		g.setBackgroundColor(ColorConstants.darkGreen);
		leftSide.addPoint(new Point(r.x,r.y));
		leftSide.addPoint(new Point(r.x+10,r.y + 5));
		leftSide.addPoint(new Point(r.x,r.bottom()));
		g.fillPolygon(leftSide);		
		g.fillRectangle(r.x+10,r.y,3,20);
		
	}

}