package org.eclipse.gef.asindesigner.figures;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.PolygonDecoration;
import org.eclipse.draw2d.PolylineConnection;
import org.eclipse.gef.asindesigner.model.SimpleOutput;
import org.eclipse.gef.asindesigner.model.Wire;

public class FigureFactory {

public static PolylineConnection createNewBendableWire(Wire wire){
	PolylineConnection conn = new PolylineConnection();
//	conn.setSourceDecoration(new PolygonDecoration());
	conn.setTargetDecoration(new PolygonDecoration());
    
	return conn;
}

public static PolylineConnection createNewWire(Wire wire){

	PolylineConnection conn = new PolylineConnection();
	PolygonDecoration arrow;
	
	if (wire == null || wire.getSource() instanceof SimpleOutput)
		arrow = null;
	else {
		arrow = new PolygonDecoration();
		arrow.setTemplate(PolygonDecoration.INVERTED_TRIANGLE_TIP);
		arrow.setScale(5,2.5);
	}
	conn.setSourceDecoration(arrow);
	
	if (wire == null || wire.getTarget() instanceof SimpleOutput)
		arrow = null;
	else {
		arrow = new PolygonDecoration();
		arrow.setTemplate(PolygonDecoration.INVERTED_TRIANGLE_TIP);
		arrow.setScale(5,2.5);
	}
	conn.setTargetDecoration(arrow);
	return conn;
}

//public static IFigure createNewLED(){
//	return new LEDFigure();
//}

public static IFigure createNewCircuit(){
	NTerminalFigure f = new NTerminalFigure();
	return f;
}
public static IFigure createNewCircuit2(){
	TerminalFigure f = new TerminalFigure();
	return f;
}
public static IFigure createNewCircuit3(){
	LeftSideFigure f = new LeftSideFigure();
	return f;
}
}