package org.eclipse.gef.asindesigner.figures;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.PointList;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.asindesigner.model.LambdaAlternative;


/**
 * @author danlee
 */
public class LambdaAlternativeFigure extends GateFigure {
private static final Dimension SIZE = new Dimension(34,34);
private static final PointList GATE_OUTLINE = new PointList();

static {
	GATE_OUTLINE.addPoint(2, 10);
	GATE_OUTLINE.addPoint(2, 2);
	GATE_OUTLINE.addPoint(4, 4);
	GATE_OUTLINE.addPoint(6, 5);
	GATE_OUTLINE.addPoint(7, 5);
	GATE_OUTLINE.addPoint(8, 5);
	GATE_OUTLINE.addPoint(10, 4);
	GATE_OUTLINE.addPoint(12, 2);
	GATE_OUTLINE.addPoint(12, 10);
}	

/**
 * Creates a new LambdaAlternativeFigure
 */
public LambdaAlternativeFigure() {	
	FixedConnectionAnchor inputConnectionAnchorA;//, inputConnectionAnchorB;
	inputConnectionAnchorA = new FixedConnectionAnchor(this);
	inputConnectionAnchorA.offsetH = 2;
	inputConnectionAnchorA.offsetV = 15;
	//inputConnectionAnchorB = new FixedConnectionAnchor(this);
	//inputConnectionAnchorB.offsetH =10;
	inputConnectionAnchors.addElement(inputConnectionAnchorA);
	//inputConnectionAnchors.addElement(inputConnectionAnchorB);
	connectionAnchors.put(LambdaAlternative.TERMINAL_A, inputConnectionAnchorA);
	//connectionAnchors.put(LambdaAlternative.TERMINAL_B, inputConnectionAnchorB);
	setBackgroundColor(AsinColorConstants.orGate);
}

/**
 * @see org.eclipse.draw2d.Figure#getPreferredSize(int, int)
 */
public Dimension getPreferredSize(int wHint, int hHint) {
	return SIZE;
}

/**
 * @see org.eclipse.draw2d.Figure#paintFigure(Graphics)
 */
protected void paintFigure(Graphics g) {
	Rectangle r = getBounds().getCopy();
	r.translate(2, 2);
	r.setSize(30,30);
	
	//g.setBackgroundColor(ColorConstants.yellow);
	//g.fillOval(r.x,r.y,30,30);
	g.setBackgroundColor(ColorConstants.black);
	g.setLineWidth(1);
	//g.drawLine(r.x+6,r.y+3,r.x+25,r.bottom()-4);
	//g.drawLine(r.x+15,r.y+15,r.x+5,r.bottom()-4);
	g.drawOval(r.x,r.y,30,30);	

}

}