package org.eclipse.gef.asindesigner.model;

import org.eclipse.gef.asindesigner.TemplateConstants;
import org.eclipse.gef.requests.CreationFactory;

public class AsinElementFactory implements CreationFactory {

	private String template;

	public AsinElementFactory(String str) {
		template = str;
	}

	protected void connect(
		AsinSubpart part1,
		String conn1,
		AsinSubpart part2,
		String conn2) {
		Wire wire = new Wire();
		wire.setSource(part1);
		wire.setSourceTerminal(conn1);
		wire.setTarget(part2);
		wire.setTargetTerminal(conn2);
		wire.attachSource();
		wire.attachTarget();
	}

	public Object getNewObject() {
		if (TemplateConstants.NTerminal.equals(template))
			return new NTerminal();
		if (TemplateConstants.Terminal.equals(template))
			return new Terminal();
		if (TemplateConstants.LeftSide.equals(template))
			return new LeftSide();
		if (TemplateConstants.Label.equals(template))
			return new AsinLabel();		
		return null;
	}

	public Object getObjectType() {
		return template;
	}
}
