package org.eclipse.gef.asindesigner.model;

import java.util.*;

import org.eclipse.draw2d.Bendpoint;

public class Wire2
	extends Wire
{


static final long serialVersionUID = 1;
protected boolean value;
protected AsinSubpart
	source,
	target;
protected String
	sourceTerminal,
	targetTerminal;
protected List bendpoints = new ArrayList();

public Wire2(){
		
}

public void attachSource(){
	if (getSource() == null || getSource().getSourceConnections().contains(this))
		return;
	getSource().connectOutput(this);
}

public void attachTarget(){
	if (getTarget() == null || getTarget().getTargetConnections().contains(this))
		return;
	//Colocando o target como alternativa do Source...	
	Object e = this.getTarget();
	if (e instanceof NTerminal || e instanceof Terminal || e instanceof LambdaAlternative){
		if(getSource() instanceof AsinDiagram){
			AsinDiagram l = (AsinDiagram)getSource();
			l.setAlternative((AsinSubpart)e);
		}				
	}		
	getTarget().connectInput(this);
}

public void detachSource(){
	if (getSource() == null)
		return;
	getSource().disconnectOutput(this);
}

public void detachTarget(){
	if (getTarget() == null)
		return;
//	Removendo o target como alternativa do Source...	
	Object e = this.getTarget();
	if (e instanceof NTerminal || e instanceof Terminal || e instanceof LambdaAlternative){
	  	if(getSource() instanceof AsinDiagram){
			  AsinDiagram l = (AsinDiagram)getSource();
			  l.setAlternative(null);			
		}	
	}	
	getTarget().disconnectInput(this);
}

public List getBendpoints() {
	return bendpoints;
}

public AsinSubpart getSource(){
	return source;
}

public String getSourceTerminal(){
	return sourceTerminal;
}

public AsinSubpart getTarget(){
	return target;
}

public String getTargetTerminal(){
	return targetTerminal;
}

public boolean getValue(){
	return value;
}

public void insertBendpoint(int index, Bendpoint point) {
	getBendpoints().add(index, point);
	firePropertyChange("bendpoint", null, null);//$NON-NLS-1$
}

public void removeBendpoint(int index) {
	getBendpoints().remove(index);
	firePropertyChange("bendpoint", null, null);//$NON-NLS-1$
}

public void setBendpoint(int index, Bendpoint point) {
	getBendpoints().set(index, point);
	firePropertyChange("bendpoint", null, null);//$NON-NLS-1$
}

public void setBendpoints(Vector points) {
	bendpoints = points;
	firePropertyChange("bendpoint", null, null);//$NON-NLS-1$
}

public void setSource(AsinSubpart e){
	Object old = source;
	source = e;
	firePropertyChange("source", old, source);//$NON-NLS-1$
}

public void setSourceTerminal(String s){
	Object old = sourceTerminal;
	sourceTerminal = s;
	firePropertyChange("sourceTerminal", old, sourceTerminal);//$NON-NLS-1$
}

public void setTarget(AsinSubpart e){
	target = e;
}

public void setTargetTerminal(String s){
	targetTerminal = s;
}

public void setValue(boolean value){
	if (value == this.value) return;
	this.value = value;
	if (target != null)
		target.update();
	firePropertyChange("value", null, null);//$NON-NLS-1$
}

public String toString() {
	return "Wire2(" + getSource() + "," + getSourceTerminal() + "->" + getTarget() + "," + getTargetTerminal() + ")";//$NON-NLS-5$//$NON-NLS-4$//$NON-NLS-3$//$NON-NLS-2$//$NON-NLS-1$
}

}
