/*
 * Created on 21/08/2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.eclipse.gef.asindesigner.model.analisador;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Iterator;
import java.util.Stack;

import org.eclipse.gef.asinview.AsinView;

/**
 * @author gohan
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

public class Asin {
	private SemanticRoutines sr;
	private String sourceFile;
	private String currentSymbol;
	private Object currentSemanticSymbol;
	private String pastSymbol;
	private String wrongLine;
	private Yytoken tokenAtual;
	private Stack asinStack;
	private Stack parseStack;
	private Stack nTermStack;
	private TabGraphNode TabGraph[];
	private TabNode TabT[];
	private TabNode TabNt[];
	private BufferedReader in;
	private File fileIn;
	private AsinStackNode asinSNode;
	private ParseStackNode auxParseSNode;

	int I;
	int IU;
	int toppsIU;
	private Yylex lex;
	boolean continueSentinel;

	public Asin(TabGraphNode tbG[],TabNode tbT[],TabNode tbNt[],String sourceFile) {
		this.sourceFile = sourceFile;
		currentSemanticSymbol = null;
		chargeFile();
		/*2     Initialize and Delare asinStack*/
		asinStack = new Stack();
		/*2     Initialize and Declare parseStack*/
		parseStack = new Stack();
		/*2     Initialize and Declare nTermStack*/
		nTermStack = new Stack();
		/*2     Initialize and Declare semanticStack*/
		Object lixo;
		/*2     Declaration of boolean variable sucesso*/
		boolean sucess;
		TabGraph = tbG;
		TabT = tbT;
		TabNt = tbNt;
		/*Construct semantic routines*/
		sr =
			new SemanticRoutines(parseStack,TabT);

		/*2     Initialize and Declare the scanner Jflex*/
		lex = new Yylex(in);
		/*Passing the Tab of terminals to scanner*/
		lex.TabT(TabT);

		int objective = 1;
		/*2     To let the things work, TabGraph[0]=(false,objetivo,0,0)*/
		TabGraph[0] = new TabGraphNode();
		TabGraph[0].term(false);
		TabGraph[0].sim(objective);
		TabGraph[0].alt(0);
		TabGraph[0].suc(0);
		/*2     Read the first entry's simbol and put in currentSymbol*/
		readNext();
		/*2     Initialization of analyser stack*/
		asinStack.push(new AsinStackNode(0, 1));
		/*2     Inicia o percurso do grafo sintatico pelo primeiro n apontado pelo simbolo no terminal inicial*/
		I = TabNt[objective].prim();
		IU = I;
		toppsIU = this.parseStack.size();
		/*2     Initialize the sentinel*/
		continueSentinel = true;
		/*2     go through the parser graph*/
		while (continueSentinel) {
			/*2       No chegou ao fim do lado direito de uma produo:*/
			if (I != 0) {
				/*2          Is current node a terminal?*/
				if (TabGraph[I].term())
					/*2             Is terminal a empty chain?*/
					if (TabGraph[I].sim() == 0) {
						/*calling the semantic routine*/
						sr.setCurrentToken(null);
						sr.execFunction(TabGraph[I].sem());
						I = TabGraph[I].suc();
						IU = I;
						toppsIU = this.parseStack.size();						
					} else {
						/*2                 I isn't the lambda-node*/
						if ((TabT[TabGraph[I].sim()].name())
							.equals(currentSymbol)) {
							/*2                     Se o n representado por I  igual ao ultimo valor lido.*/
							/*2                         Ento coloque o ultimo valor lido na parseStack*/
							parseStack.push(new ParseStackNode(currentSymbol,currentSemanticSymbol));
							printStack(parseStack);
							/*2                          chamada da RS referenciada pelo n terminal reconhecido*/
							sr.setCurrentToken(tokenAtual);
							sr.execFunction(TabGraph[I].sem());
							readNext();
							/*2                         Acabei de reconhecer um simbolo, posso esvaziar a pilhaNoTerminal*/
							nTermStack.clear();
							/*2                         Faa I <- sucessor do I atual*/
							I = TabGraph[I].suc();
							IU = I;
							toppsIU = this.parseStack.size();
						} else {
							/*2                     Se o n representado por I no  igual ao ultimo valor lido */
							if (TabGraph[I].alt() != 0)
								/*2                         Se o n representado por I possui alternativa.*/
								/*2                             Faa o I representar essa alternativa*/
								I = TabGraph[I].alt();
							else {
								/*2                         Se o n representado por I no possui alternativa*/
								if (nTermStack.empty()) {
									/*2                             Se a pilhaNoTerminal est vazia, tenho que tratar o erro*/
									dealWithError(
										IU,
										toppsIU,
										tokenAtual.m_charBegin,
										tokenAtual.m_line);
								} else {
									/*2                             Se a pilhaNoTerminal no est vazia.*/
									/*2                                 Desempilho ento um n da pilha, que no caso corresponde a uma no terminal,*/
									/*2                                 e atribuo  I o n alternativo desse no terminal*/
									int alternative;
									alternative =
										this.findAlternative(
											I,
											nTermStack,
											asinStack);
									if (alternative != 0) {
										I = alternative;
									} else {
										dealWithError(
											IU,
											toppsIU,
											tokenAtual.m_charBegin,
											tokenAtual.m_line);
									}
								}
							}
						}
					}
				else {
					/*2             Se I no representa n terminal*/
					/*2                 Empilha o n representado por I na pilha do analisador*/
					asinStack.push(
						new AsinStackNode(I, parseStack.size() + 1));
					/*2                 Empilha o n representado por I na pilhaNoTerminal*/
					nTermStack.push(new Integer(I));
					/*2                 Fao I representar o primeiro n desse nao terminal*/
					I = TabNt[TabGraph[I].sim()].prim();
				}
			} else {
				/*2         Terminou o lado direito de uma produo?*/
				if (!asinStack.empty()) {
					/*2             A pilha do analisador no est vazia?*/
					/*2                 Desempilha o n da pilha do analisador e coloco-o em asinSNode*/
					asinSNode = (AsinStackNode) asinStack.pop();
					/*2                 Desempilho todos os ns da parseStack que representam o no terminal reconhecido*/
					while (parseStack.size() >= asinSNode.r) {
						auxParseSNode = (ParseStackNode)parseStack.pop();
					}
					/*2                 Empilha na parseStack o n do no terminal reconhecido*/
					parseStack.push(new ParseStackNode(TabNt[TabGraph[asinSNode.no].sim()].name(),auxParseSNode.sem()));
					printStack(parseStack);
					/*2                 Fao I representar o n correspondente  asinSNode*/
					I = asinSNode.no;
					/*2                 Chamada a rotina semantica referenciada pelo n no-terminal reconhecido*/
					sr.setCurrentToken(tokenAtual);
					sr.execFunction(TabGraph[I].sem());
					/*2                 Fao I representar o n sucessor ao I atual*/
					I = TabGraph[I].suc();
					IU = I;
					toppsIU = this.parseStack.size();
				} else {
					/*2             No atigiu o lado direito de uma produao*/
					/*2             Se a pilha do analisador est vazia*/
					if (currentSymbol.equals(new String("$"))) {
						/*2                 Se a ultima palavra lida for igual ao final de arquivo*/
						/*2                     Ento reconheci a linguagem...*/
						//AsinView.displayText("End of File");
						sucess = true;
					} else {
						/*2                 Se a ultima palavra lida no for igual ao final de arquivo*/
						/*2                      Ento no reconheci a linguagem...*/
						AsinView.displayText(
							"The fist non-teminal of the grammar has been recognized. ");
						AsinView.displayText(
							"But the end-of-file symbol has not been recognized.");
						sucess = false;
					}
					/*2                Indica que deve encerrar a analise*/
					continueSentinel = false;
				}
			}
		}
	}

	/*carregando a entrada a ser analisada....*/
	private void chargeFile() {
		String path = sourceFile;
		//new String("c:\\Fernando\\eclipse\\workspace\\org.eclipse.analisadorSintatico\\src\\org\\eclipse\\analisadorSintatico\\entrada.txt");
		//new String("/home/chaos/workspace/AnalisadorSintatico/Arquivos/entrada.txt");
		fileIn = new File(path);
		try {
			in = new BufferedReader(new FileReader(fileIn));
		} catch (FileNotFoundException e) {
			AsinView.displayText("File not found");
		}
	}

	/*A rotina de tratamento de erro  chamada quando o sibolo lido no coincide com os simbolos esperados, nesse 
	 * caso, tentamos quatro tcnicas de correo de erros so elas:
	 * a)Eliminao de um smbolo: Nesta estratgia supomos que o usurio cometeu o engano de escrever a cadeia
	 * de entrada com um simbolo a mais. Tal simbolo (o simbolo que acabou de ser lido) deve ento ser eliminado.
	 * b)Insero de um smbolo: Nessa estratgia supomos que o usurio cometeu o engano de omitir um smbolo que 
	 * deve ser inserido.
	 * c)Um smbolo trocado: Nesta estratgia supomos que o usurio escreveu um smbolo erradamente.
	 * d)Busca de Delimitador: Nesta estratgia, procuramos um simbolo que delimite o no terminal sendo procurado.*/
	private void dealWithError(int IX, int toppsIU, int column, int line) {
		int oldI = IX;
		String txt ="";
		Object lixo;
		/*o proximo bloco  responsvel por imprimir na tela aonde o erro ocorreu*/
		try {
			BufferedReader bf = new BufferedReader(new FileReader(fileIn));
			for (int j = 0; j < line; j++) {
				bf.readLine();
			}
			/*Imprime a linha que occorreu o erro*/
			wrongLine = bf.readLine();
			AsinView.displayText("\n" + wrongLine + "\n");
		} catch (IOException e) {
			AsinView.displayText("File not found...");
		}
		//AsinView.displayText("\nErro:");
		AsinView.displayText("Error found at the symbol of line: "+line+", column: "+column+". ");
		//for (int i = 0; i < column; i++)
		//	txt = txt+"_";
		//AsinView.displayText(txt+"^: ");
		/*falta fazer back-tracking*/
		while (IX != 0) {
			/*eh terminal?*/
			if (TabGraph[IX].term()) {
				/*emite terminal esperado*/
				AsinView.displayText(TabT[TabGraph[IX].sim()].name() + "  ");
				/*vai para a proxima alternativa*/
				IX = TabGraph[IX].alt();
			} else {
				/*no nao terminal*/
				IX = TabNt[TabGraph[IX].sim()].prim();
			}
		}
		AsinView.displayText(" expected. ");
		/*Tenta corrigir o erro utilizando a estratgia da eliminao*/
		if (!estrategiaEliminacao(oldI, toppsIU, column, line)) {
			AsinView.errorRecoveryStatus(
				"\nDeleting a symbol strategy has not succeeded\n");
			/*Tenta corrigir o erro utilizando a estratgia de insero*/
			if (!estrategiaInsercao(oldI, toppsIU, column, line)) {
				AsinView.errorRecoveryStatus(
					"Inserting a symbol strategy has not succeeded\n");
				/*Tenta corrigir o erro utilizando a estratgia da troca*/
				if (!estrategiaTroca(oldI, toppsIU, column, line)) {
					AsinView.errorRecoveryStatus(
						"Replacing a symbol stategy has not succeeded\n");
					/*Tenta corrigir o erro utilizando a estratgia da busca de Delimitador*/
					if (!estrategiaBuscaDelimitador(oldI,toppsIU,column,line)) {
						AsinView.errorRecoveryStatus(
							"Searching delimiters strategy has not succeeded\n");
						/*At esse ponto nenhuma das estratgias tiveram sucesso ao corrigir o erro, ento o prximo
						 * simbolo da entrada  lido a rotina de tratamento de erros  chamada novamente. Dessa vez 
						 * para esse novo simbolo lido.*/
						this.readNext();
						if(tokenAtual.m_text.equals("$"))
							continueSentinel = false;
						else this.dealWithError(oldI,toppsIU,tokenAtual.m_charBegin,tokenAtual.m_line);
					}
				}
			}
		}
	}

	private boolean estrategiaBuscaDelimitador(
		int IX,
		int topps,
		int column,
		int line) {
		boolean achou = false;
		Object lixo;
		Stack pilhaAnalisadorBackup = new Stack();
		Stack pilhaAuxAnalisador = new Stack();
		Stack pilhaNaoTerminalY = new Stack();
		AsinStackNode temp;
		pilhaAnalisadorBackup = (Stack) this.asinStack.clone();
		int toppsAux;
		int IY;
		/*percorre a pilha do analisador*/
		while (!asinStack.empty() && !achou) {
			/*Ainda existem alternativas a seguir ou  necessario desempilhar um n na pilha do analisador*/
			toppsAux = this.parseStack.size();
			if (IX != 0) {
				/*Procurando por um no terminal*/
				while (IX != 0 && this.TabGraph[IX].term())
					IX = this.TabGraph[IX].alt();
			}
			/*Preciso desempilhar um n da pilha do analisador*/
			if (IX == 0) {
				/*desempilha e vai para o percurso*/
				temp = (AsinStackNode) asinStack.pop();
				IX = temp.no;
				toppsAux = temp.r;
			}
			/*inicio do percurso*/
			IY = this.TabGraph[IX].suc();
			/*inicializando as duas pilhas auxiliares...*/
			pilhaNaoTerminalY.clear();
			pilhaAuxAnalisador.clear();
			/*percurso*/
			while (IY != 0 && !achou) {
				/* terminal?*/
				if (this.TabGraph[IY].term()) {
					/* lambda-n?*/
					if (this.TabGraph[IY].sim() == 0) {
						IY = this.TabGraph[IY].suc();
					} else {
						String tmp = this.TabT[this.TabGraph[IY].sim()].name();
						if (tmp.equals(this.currentSymbol)) {
							while (this.parseStack.size() >= toppsAux) {
								lixo = this.parseStack.pop();
							}
							this.parseStack.push(new ParseStackNode(this.TabNt[this.TabGraph[IX].sim()].name()));
							achou = true;
							I = IY;
						} else
							IY =
								this.findAlternative(
									IY,
									pilhaNaoTerminalY,
									pilhaAuxAnalisador);
					}
				} else { /* no terminal*/
					pilhaAuxAnalisador.push(new AsinStackNode(IY, toppsAux));
					pilhaNaoTerminalY.push(new Integer(IY));
					IY = this.TabNt[this.TabGraph[IY].sim()].prim();

				}
			}
			if(!achou)
				IX = this.TabGraph[IX].alt();
		}
		if (achou) {
			/*copia a pilha auxiliar do analisador na pilha do analisador...*/
			for (int i = 0; i < pilhaAuxAnalisador.size(); i++) {
				this.asinStack.push(pilhaAuxAnalisador.elementAt(i));
			}
			//AsinView.displayText(wrongLine);
			//for (int i = 0; i < column; i++)
			//	AsinView.displayText(">");
			AsinView.displayText("Action: the symbol in the column "+column+" has been assumed as delimiter.\n");
		} else {
			/*Deixa tudo como estava...*/
			this.asinStack = (Stack) pilhaAnalisadorBackup.clone();
		}
		return achou;
	}

	private boolean estrategiaTroca(int IX, int toppsIU, int column, int line) {
		int IY;
		Stack pilhaNaoTerminalY = new Stack();
		boolean achou = false;
		/*Esquecer os no terminais que aparecem na pilha do analisador ao 
		 * tentar as outras correos*/
		while (asinStack.size() > toppsIU)
			asinStack.pop();
		/*le o proximo simbolo*/
		this.readNext();
		int topps = this.parseStack.size();
		/*Percorre os ns que podem ser inseridos (t1,t2....,tn)*/
		while (IX != 0 && !achou) {
			/*o simbolo espereado  terminal?*/
			if (this.TabGraph[IX].term()) {
				IY = this.TabGraph[IX].suc();
				pilhaNaoTerminalY.clear();
				/*percorre s1,s2,...,sn*/
				while (IY != 0 && !achou) {
					/* terminal?*/
					if (this.TabGraph[IY].term()) {
						/* lambda-n?*/
						if (this.TabGraph[IY].sim() == 0) {
							IY = this.TabGraph[IY].suc();
						} else {
							String temp =
								this.TabT[this.TabGraph[IY].sim()].name();
							if (temp.equals(this.currentSymbol)) {
								/*empilha ti na pilha sinttica...*/
								this.parseStack.push(new ParseStackNode(this.TabT[this.TabGraph[IX].sim()].name()));
								this.printStack(parseStack);
								topps++;
								/*novo n para asin...*/
								I = IY;
								/*correo obteve sucesso...*/
								achou = true;
							} else
								IY =
									this.findAlternative(
										IY,
										pilhaNaoTerminalY,
										asinStack);
						}
					}
					/*sucessor  um no terminal*/
					else {
						this.asinStack.push(new AsinStackNode(IY, topps + 2));
						pilhaNaoTerminalY.push(new Integer(IY));
						IY = this.TabNt[this.TabGraph[IY].sim()].prim();
					}
				}
				/*Nesse ponto a pilhaNaoTerminalY est vazia, portanto qualquer n que tenha sido colocado
				 * na asinStack na busca das alternativas do n IY, j foi removido. Logo,  posso 
				 * desenpilhar um n da pilha do analisador na busca de uma alternativa do n IX sem 
				 * problemas pois se a nTermStack no est vazia, o topo da pilha do analisador representa
				 * um n no terminal que foi utilizado para chegar at o n IX.*/
				if (!achou)
					IX = this.findAlternative(IX, nTermStack, asinStack);
			} else {
				/*no terminal na sequencia dos esperados*/
				this.asinStack.push(new AsinStackNode(IX, topps + 1));
				this.nTermStack.push(new Integer(IX));
				IX = this.TabNt[this.TabGraph[IX].sim()].prim();
			}
		}
		if (achou) {
			/*novo topo...*/
			/*volta um token na cabea de leitura do analisador lxico.*/
			//lex.yypushback(lex.yylength());
			AsinView.displayText(
				"Action: This symbol has been replaced by "
					+ this.TabT[this.TabGraph[IX].sim()].name()+"\n");
		} else {
			currentSymbol = pastSymbol;
			/*volta um token na cabea de leitura do analisador lxico.*/
			lex.pushback(lex.yylength());
			/*Faz com que a pilha do analisador volte a ser o que era antes de usar essa estratgia.*/
			while (this.asinStack.size() > toppsIU) {
				Object lixo;
				lixo = this.asinStack.pop();
			}
		}
		return achou;
	}

	private boolean estrategiaInsercao(
		int IX,
		int toppsIU,
		int column,
		int line) {
		int IY;
		Stack pilhaNaoTerminalY = new Stack();
		boolean achou = false;
		//int topo = this.asinStack.size()-1;
		int topps = this.parseStack.size();
		//int topoaux1 = topo;
		//int topoaux2 = 0;
		/*Percorre os ns que podem ser inseridos (t1,t2....,tn)*/
		while (IX != 0 && !achou) {
			/*o simbolo espereado  terminal?*/
			if (this.TabGraph[IX].term()) {
				//topoaux2 = topoaux1;
				IY = this.TabGraph[IX].suc();
				pilhaNaoTerminalY.clear();
				/*percorre s1,s2,...,sn*/
				while (IY != 0 && !achou) {
					/* terminal?*/
					if (this.TabGraph[IY].term()) {
						/* lambda-n?*/
						if (this.TabGraph[IY].sim() == 0) {
							IY = this.TabGraph[IY].suc();
						} else {
							String temp =
								this.TabT[this.TabGraph[IY].sim()].name();
							if (temp.equals(this.currentSymbol)) {
								/*empilha ti na pilha sinttica...*/
								this.parseStack.push(new ParseStackNode(this.TabT[this.TabGraph[IX].sim()].name()));
								this.printStack(parseStack);
								topps++;
								/*novo n para asin...*/
								I = IY;
								/*correo obteve sucesso...*/
								achou = true;
							} else
								IY =
									this.findAlternative(
										IY,
										pilhaNaoTerminalY,
										asinStack);
						}
					}
					/*sucessor  um no terminal*/
					else {
						//topoaux2 = topoaux2 + 1;
						//this.asinStack.add(topoaux2,new AsinStackNode(IY, topps + 2));
						this.asinStack.push(new AsinStackNode(IY, topps + 2));
						pilhaNaoTerminalY.push(new Integer(IY));
						IY = this.TabNt[this.TabGraph[IY].sim()].prim();
					}
				}
				/*Nesse ponto a pilhaNaoTerminalY est vazia, portanto qualquer n que tenha sido colocado
				 * na asinStack na busca das alternativas do n IY, j foi removido. Logo,  posso 
				 * desenpilhar um n da pilha do analisador na busca de uma alternativa do n IX sem 
				 * problemas pois se a nTermStack no est vazia, o topo da pilha do analisador representa
				 * um n no terminal que foi utilizado para chegar at o n IX.*/
				if (!achou)
					IX = this.findAlternative(IX, nTermStack, asinStack);
			} else {
				/*no terminal na sequencia dos esperados*/
				//topoaux1 = topoaux1 + 1;
				//this.asinStack.add(topoaux1,new AsinStackNode(IX, topps + 1));
				this.asinStack.push(new AsinStackNode(IX, topps + 1));
				this.nTermStack.push(new Integer(IX));
				IX = this.TabNt[this.TabGraph[IX].sim()].prim();
			}
		}
		if (achou) {
			/*novo topo...*/
			//topo = topoaux2;
			//currentSymbol = pastSymbol;
			/*volta um token na cabea de leitura do analisador lxico.*/
			//lex.yypushback(lex.yylength());
			AsinView.displayText(
				"Action: "
					+ this.TabT[this.TabGraph[IX].sim()].name()
					+ " inserted before column "+column+"\n");
		}
		/*deixa a pilha do Analisador como estava antes de comear essa estratgia*/
		else {
			while (this.asinStack.size() > toppsIU) {
				Object lixo;
				lixo = this.asinStack.pop();
			}

		}
		return achou;
	}

	private boolean estrategiaEliminacao(
		int IX,
		int toppsIU,
		int column,
		int line) {
		boolean sucesso = false;
		Object lixo;
		/*ler o proximo simbolo*/
		readNext();
		/*Tenta achar um terminal que seja igual ao simbolo lido, percorrendo as alternativas do n atual*/
		while (IX != 0) {
			/*eh terminal?*/
			if (TabGraph[IX].term()) {
				/*o simbolo deste terminal  igual ao simbolo atual?*/
				if (TabT[TabGraph[IX].sim()].name().equals(currentSymbol)) {
					/*2                     Se o n representado por I  igual ao ultimo valor lido.*/
					/*2                         Ento coloque o ultimo valor lido na parseStack*/
					parseStack.push(new ParseStackNode(currentSymbol,currentSemanticSymbol));
					//imprimePilha(parseStack);
					readNext();
					/*2                         Acabei de reconhecer um simbolo, posso esvaziar a pilhaNoTerminal*/
					nTermStack.clear();
					/*2                         Faa I <- sucessor do IX atual*/
					I = TabGraph[IX].suc();
					IU = I;
					toppsIU = this.parseStack.size();
					/*imprimir mensagem que o penultimo simbolo lido foi ignorado*/
					AsinView.displayText("Action: This symbol will be ignorated\n");
					/*consegui corrigir*/
					sucesso = true;
					/*sair do lao*/
					break;
				} else {
					/*no  igual, vai para a proxima alternativa*/
					int alternative = 0;
					alternative =
						this.findAlternative(IX, nTermStack, asinStack);
					IX = alternative;
				}
			} else {
				/*2             Se IX no representa n terminal*/
				/*2                 Empilha o n representado por IX na pilha do analisador*/
				asinStack.push(new AsinStackNode(IX, parseStack.size() + 1));
				/*2                 Empilha o n representado por IX na pilhaNoTerminal*/
				nTermStack.push(new Integer(IX));
				/*2                 Fao IX representar o primeiro n desse nao terminal*/
				IX = TabNt[TabGraph[IX].sim()].prim();
			}
		}
		if (!sucesso) {
			currentSymbol = pastSymbol;
			/*volta um token na cabea de leitura do analisador lxico.*/
			lex.pushback(lex.yylength());
			while (this.asinStack.size() > toppsIU) {
				lixo = this.asinStack.pop();
			}
		}
		return sucesso;
	}

	public void printStack(Stack s) {
		Iterator i = s.iterator();
		ParseStackNode tmp;
		while (i.hasNext()) {
			tmp = (ParseStackNode)i.next();
			AsinView.printSyntaxStack(tmp.syn() + "  ");
			AsinView.printSemanticStack(tmp.sem() + " ");
		}
		AsinView.printSyntaxStack("\n");
		AsinView.printSemanticStack("\n");
	}

	class AsinStackNode {
		public int no;
		public int r;
		AsinStackNode(int no, int r) {
			this.no = no;
			this.r = r;
		}
		public String toString() {
			return no + "," + r;

		}
	}

	/*Esta funo l o proximo token de entrada, guardando o token em tokenAtual e o simbolo correspondente em 
	  simbolo Atual */
	public void readNext() {
		try {
			tokenAtual = lex.yylex();
			//System.err.println(lex.yylength());
			pastSymbol = currentSymbol;
			String tkAp1 = tokenAtual.m_p1;
			if (tkAp1.equals("Res") || tkAp1.equals("Esp")||tkAp1.equals("EOF")){
				currentSymbol = tokenAtual.m_text;
			}
			else{ 
				currentSymbol = tokenAtual.m_p1;
			}	
			currentSemanticSymbol = tokenAtual.m_text;		
		} catch (IOException e) {
			AsinView.printToken("Token read error\n");
		}
		AsinView.printToken("Current Token: "+tokenAtual+"\n");
	}

	/*Esta funo  chamada quando o n atual no possui como alternativa um terminal mas sim um no terminal.
	 * Ento percorremos os no terminais guardados na pilha noTerminal at achar um simbolo terminal. Como
	 * tal simbolo  alternativa do n sendo visitado, retornamos ele. Se no existe tal simbolo, retornamos "0"
	 * para indicar que o n no possui alternativas. 
	 */
	private int findAlternative(int IZ, Stack pilhaNaoTerm, Stack pilhaAna) {
		Object trash;
		int alternative = 0;
		alternative = this.TabGraph[IZ].alt();
		while (alternative == 0 && !pilhaNaoTerm.empty()) {
			trash = pilhaAna.pop();
			alternative =
				TabGraph[((Integer) pilhaNaoTerm.pop()).intValue()].alt();
		}
		return alternative;
	}
}
