/*
 * Created on 12/03/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package org.eclipse.gef.asindesigner.model.analisador;

import java.util.Stack;

import org.eclipse.gef.asinview.AsinView;




public class SemanticRoutines {
	/*The user may add variables of any type.*/
	private Stack parseStack; //This variable is the parse Stack. **Should not be removed.**
	private TabNode TabT[];//This variable is the table of reserved symbols. **Should not be removed.**
	private Yytoken currentToken;//This variable contains the last recognized token **Should not be removed.**
      
	/*The constructor of this class*/
	public SemanticRoutines(Stack parseS,TabNode tbT[]) {   
		parseStack = parseS;
		TabT = tbT;
	}

	/*The parse calls this method when it recognizes a token. Thus the variable currentToken contains the last
	 * recognized token*/
	public void setCurrentToken(Yytoken cToken) {
		currentToken = cToken;
	}	
    /*The method below switches to the semantic routine to executed. In this default file, there are only 3
     * semantic routines; if the user wants to add more routines, he should add them here, e.g.:
     * case 5:
     *         this.rs5();
     *         break;
     * ...
     **/
	public void execFunction(int r) {
		switch (r) {
			/*the value -1 indicates the node without semantic routine*/
			case -1 :
				//AsinView.semanticRoutinesOutput("The recognized node has not semantic routine\n");
				break;
			case 1 :
				this.rs1();
				break;
			case 2 :
				this.rs2();
				break;
			case 3 :
				this.rs3();
				break;
			default :
		}
	}

	  /*Here begin the codes for the semantic routines. If the user wants to add a semantic routine, he should create a method for it, e.g.:
     *   private void rs5(){....}.
     * The name and return value of this method must be coherent with the method execFunction above.*/
	private void rs1() {
		ParseStackNode aux;
		int index = this.parseStack.size()-1;//top
		int acumulator;
		aux = (ParseStackNode)this.parseStack.elementAt(index);
		acumulator = aux.intSem();
		index--;
		while(index > 0){
			aux = (ParseStackNode)this.parseStack.elementAt(index);
			if(aux.syn().equals("+")){
				index--;
				aux = (ParseStackNode)this.parseStack.elementAt(index);
				acumulator = acumulator + aux.intSem();
				index--;				
			}
			else if(aux.syn().equals("-")){
				index--;
				aux = (ParseStackNode)this.parseStack.elementAt(index);
				acumulator = aux.intSem() - acumulator;
				index--;
			}else{								
				break;
			}			
		}
		/* Stores the final result assigned to the non-terminal T into the first parse and semantic stack cell of T;
		 * this way, the semantic stack will show the partial and final results. */
		((ParseStackNode)this.parseStack.elementAt(++index)).sem(acumulator+"");
		if(index <= 0){
			AsinView.semanticRoutinesOutput("Result: "+acumulator+"\n");						
		}
	}
	private void rs2() {
		ParseStackNode aux;
		int index = this.parseStack.size()-1;//top
		int acumulator;
		aux = (ParseStackNode)this.parseStack.elementAt(index);
		acumulator = aux.intSem();
		index--;
		while(index >= 0){
			aux = (ParseStackNode)this.parseStack.elementAt(index);
			if(aux.syn().equals("*")){
				index--;
				aux = (ParseStackNode)this.parseStack.elementAt(index);
				acumulator = acumulator * aux.intSem();
				index--;				
			}
			else if(aux.syn().equals("/")){
				index--;
				aux = (ParseStackNode)this.parseStack.elementAt(index);
				acumulator = aux.intSem() / acumulator;
				index--;
			}else{							
				break;
			}			
		}
		/* Stores the final result assigned to the non-terminal T into the first parse and semantic stack cell of T;
		 * this way, the semantic stack will show the partial and final results. */
		((ParseStackNode)this.parseStack.elementAt(++index)).sem(acumulator+"");				
	}
	private void rs3() {
		Object aux;
		int index = this.parseStack.size()-1;//top
		aux = ((ParseStackNode)this.parseStack.elementAt(index-1)).sem();
		((ParseStackNode)this.parseStack.elementAt(index-2)).sem(aux);		
	}		
}
