package org.eclipse.gef.asindesigner.model.commands;

import org.eclipse.gef.asindesigner.AsinMessages;
import org.eclipse.gef.asindesigner.model.AsinDiagram;
import org.eclipse.gef.asindesigner.model.AsinSubpart;

public class AddCommand extends
	org.eclipse.gef.commands.Command
{

private AsinSubpart child;
private AsinDiagram parent;
private int index = -1;

public AddCommand() {
	super(AsinMessages.AddCommand_Label);
}

public void execute() {
	if( index < 0 )
		parent.addChild(child);
	else
		parent.addChild(child,index);
}

public AsinDiagram getParent() {
	return parent;
}

public void redo() {
	if( index < 0 )
		parent.addChild(child);
	else
		parent.addChild(child,index);
}

public void setChild(AsinSubpart subpart) {
	child = subpart;
}

public void setIndex(int i){
	index = i;
}

public void setParent(AsinDiagram newParent) {
	parent = newParent;
}

public void undo() {
	parent.removeChild(child);
}

}