package org.eclipse.gef.asindesigner.model.commands;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.asindesigner.AsinMessages;
import org.eclipse.gef.asindesigner.model.AsinDiagram;
import org.eclipse.gef.asindesigner.model.AsinSubpart;

public class CreateCommand
	extends org.eclipse.gef.commands.Command
{

private AsinSubpart child;
private Rectangle rect;
private AsinDiagram parent;
private int index = -1;

public CreateCommand() {
	super(AsinMessages.CreateCommand_Label);
}

public void execute() {
	if (rect != null) {
		child.setLocation(rect.getLocation());
		if (!rect.isEmpty())
			child.setSize(rect.getSize());
	}
	if( index < 0 )
		parent.addChild(child);
	else
		parent.addChild(child,index);
}

public AsinDiagram getParent() {
	return parent;
}

public void redo() {
	if (rect != null) {
		child.setLocation(rect.getLocation());
		child.setSize    (rect.getSize());
	}
	if( index < 0 )
		parent.addChild(child);
	else
		parent.addChild(child,index);
}

public void setChild(AsinSubpart subpart) {
	child = subpart;
}

public void setIndex( int index ){
	this.index = index;
}

public void setLocation (Rectangle r) {
	rect = r;
}

public void setParent(AsinDiagram newParent) {
	parent = newParent;
}

public void undo() {
	parent.removeChild(child);
}

}
