package org.eclipse.gef.asindesigner.model.commands;

import java.util.List;

import org.eclipse.gef.asindesigner.AsinMessages;
import org.eclipse.gef.asindesigner.model.AsinDiagram;
import org.eclipse.gef.asindesigner.model.AsinSubpart;
import org.eclipse.gef.commands.Command;

public class OrphanChildCommand
	extends Command
{

private AsinDiagram diagram;
private AsinSubpart child;
private int index;

public OrphanChildCommand () {
	super(AsinMessages.OrphanChildCommand_Label);
}

public void execute() {
	List children = diagram.getChildren();
	index = children.indexOf(child);
	diagram.removeChild(child);
}

public void redo() {
	diagram.removeChild(child);
}

public void setChild(AsinSubpart child) {
	this.child = child;
}

public void setParent(AsinDiagram parent) { 
	diagram = parent;
}

public void undo() {
	diagram.addChild(child,index);
}

}
