package org.eclipse.gef.asindesigner.model.commands;

import org.eclipse.gef.asindesigner.AsinMessages;
import org.eclipse.gef.asindesigner.model.AsinDiagram;
import org.eclipse.gef.asindesigner.model.AsinSubpart;
import org.eclipse.gef.commands.Command;

public class ReorderPartCommand extends Command {

private int oldIndex, newIndex;
private AsinSubpart child;
private AsinDiagram parent;

public ReorderPartCommand(AsinSubpart child, AsinDiagram parent, int oldIndex, int newIndex ) {
	super(AsinMessages.ReorderPartCommand_Label);
	this.child = child;
	this.parent = parent;
	this.oldIndex = oldIndex;
	this.newIndex = newIndex;
}

public void execute() {
	parent.removeChild(child);
	parent.addChild(child, newIndex);
}

public void undo() {
	parent.removeChild(child);
	parent.addChild(child, oldIndex);
}

}